﻿/// <reference path="jquery.1.7.2.js" />

$(document).ready(function () {
    var formObject = $('#newUserForm');
    var errorOccured = false;
    var errorMessage = "We could not submit your form. Please check the invalid field and correct it";

    //-----On focus, show info
    $('div.field').each(function () {
        var _block = $(this);
        _block.find('input').focus(function () {
            var _input = $(this);
            _block.find('.info').fadeIn(300);
        }).focusout(function () {
            _block.find('.info').fadeOut(100);
        });
    });
    //-----ENd---



    //------------validate name
    var fullNameObject = formObject.find('#fullname');
    fullNameObject.keyup(function () {
        var me = $(this);
        var myValue = me.val();
        var meError = false;
        meError |= myValue == null || typeof myValue == undefined;
        meError |= (myValue.split(' ') != null) ? myValue.split(' ').length > 4 : false; //...
        var pattern = /^([a-zA-ZÀ-ÿ\s]{3,})$/;
        var expr = new RegExp(pattern);
        meError |= !(expr.exec(myValue));
        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;
    });
    //-----------end



    //------------validate email
    var emailObject = formObject.find('#email');
    emailObject.keyup(function () {
        var me = $(this);
        var myValue = me.val();
        var meError = false;
        meError |= myValue == null || typeof myValue == undefined;
        var pattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
        var expr = new RegExp(pattern);
        meError |= !(expr.test(myValue));
        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;
    });
    //-----------end


    //------------validate passwords
    var passwordObject = formObject.find('#password');
    passwordObject.keyup(function () {
        var me = $(this);
        var myValue = me.val();
        var meError = false;
        meError |= myValue == null || typeof myValue == undefined;
        var pattern = /^.{6,}/;
        var expr = new RegExp(pattern);
        meError |= !(expr.test(myValue));
        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;
    });

    var password2Object = formObject.find('#password2');
    password2Object.keyup(function () {
        var me = $(this);
        var myValue = me.val();
        var meError = me.val() != passwordObject.val();
        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;
    });
    //-----------end



    //------------validate day
    var dayObject = formObject.find('#day');
    dayObject.keyup(function () {
        var me = $(this);
        var myValue = parseInt(me.val());
        var meError = isNaN(myValue);
        meError |= myValue < 1;
        meError |= myValue > 31;

        var pattern = /^\d{1,2}$/;
        var expr = new RegExp(pattern);

        meError |= !(expr.test(myValue));

        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;

    });
    //-----------end

    //------------validate month
    var monthObject = formObject.find('#month');
    monthObject.keyup(function () {
        var me = $(this);
        var myValue = parseInt(me.val());
        var meError = isNaN(myValue);
        meError |= myValue < 1;
        meError |= myValue > 12;

        var pattern = /^\d{1,2}$/;
        var expr = new RegExp(pattern);

        meError |= !(expr.test(myValue));

        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;
    });
    //-----------end
    //------------validate year
    var yearObject = formObject.find('#year');
    yearObject.keyup(function () {
        var me = $(this);
        var myValue = parseInt(me.val());
        var meError = isNaN(myValue);
        var thisYear = new Date().getYear() + 1900; ;
        var pattern = /^\d{4}$/;
        var expr = new RegExp(pattern);

        expr = new RegExp(pattern);
        meError |= myValue < thisYear - 100;
        meError |= !(expr.test(myValue));

        if (meError) {
            me.addClass('red_bg');
            me.parents('div.field').find('.info').fadeOut(100);
            me.parents('div.field').find('.error').fadeIn(300);
        }
        else {
            me.removeClass('red_bg');
            me.parents('div.field').find('.error').fadeOut(100);
        }
        errorOccured = meError;
    });
    //-----------end



    //-----submit form----
    //the user has clicked on the submit button, or pressed ENTER
    formObject.submit(function () {
        formObject.find('input').each(function () {
            if ($(this).val() == '' || typeof $(this).val() == undefined || $(this).val() == null) {
                errorOccured = true;
                errorMessage += "All fields are required";
            }
        });
        return !errorOccured;
    });
    //-------END

});